	
var oLongUrlField 	= null;
var oTabBox		 	= null;
var oSavedTree	 	= null;
var oSavedTreeItems	= null;
var tinyurl_loaded = false;

function tinyurl_overlayInit(){
	try{
		var oContext = document.getElementById("contentAreaContextMenu");
			oContext.setAttribute("onpopupshowing", "tinyurl_contextShowing(event); "+ oContext.getAttribute("onpopupshowing"));
	} catch(err) { alert(err); }
	
	// Update all links with preview title attribute
	if(gBrowser && !tinyurl_loaded){
	
		gBrowser.addEventListener("load", function(){
			var doc = gBrowser.selectedBrowser.contentDocument;
			TinyUrl.addPreviews(doc);
		}, true);
		
		tinyurl_loaded = true;
	}
}

/**
* Load TinyUrl dialog
*/
function tinyurl_load(){
	oLongUrlField 	= document.getElementById("longurl-field");
	oTabBox			= document.getElementById("tinyurl-tabs");
	oSavedTree		= document.getElementById("saved-tree");
	oSavedTreeItems	= document.getElementById("saved-items");
	
	// Cancel button
	document.getElementById('tinyurlDialog').getButton('cancel').setAttribute("label", "Close");
	
	// Is RDF Present
	tinyurl_saved_rdfCreate();
	
	// Load Saved Data
	tinyurl_saved_read();
	
	// Preload Field
	if(opener.gBrowser && opener.gBrowser.currentURI){
		oLongUrlField.value = opener.gBrowser.currentURI.spec;
	}
	
	// Goto Save Tab
	if(window.arguments.length > 0 && window.arguments[0] == "saved"){
		oTabBox.selectedTab		= document.getElementById("tinyurl-saved-tab");
		oTabBox.selectedPanel	= document.getElementById("tinyurl-saved-tabpanel");
	}
}

/**
* Create TinyUrl from current page
*/
function tinyurl_createFromCurrent(){
	var tiny = new TinyUrl.URL(gBrowser.currentURI.spec);
	tiny.title = window._content.document.title;
	window.openDialog('chrome://tinyurl/content/create.xul','TinyUrlCreate','chrome, centerscreen, resizable', tiny);
}

/**
* Creat new Tiny Url from dialog
*/
function tinyurl_createNew(){
	try{
		
		// If not in main tab
		if(oTabBox.selectedTab.id != "tinyurl-create-tab"){
			return;
		}
		
		// Validate
		if(oLongUrlField == null || oLongUrlField.value == ""){
			alert("You have not entered a long url");
			return;
		}
		
		document.getElementById("tinyurl-field").value = "Loading...";
		
		// Title
		var sTitle = "";
		if(opener && oLongUrlField.value == opener.gBrowser.currentURI.spec){
			sTitle = opener.window._content.document.title;
		}
		
		// Get TinyUrl and Shrink
		var tiny = new TinyUrl.URL(oLongUrlField.value);
		tiny.title = sTitle;
				
		TinyUrl.shrink(tiny, function(url){
			if(url.tiny != null){
				document.getElementById("tinyurl-field").value = url.tiny;
				document.getElementById("copy-button").disabled = false;
				document.getElementById("save-button").setAttribute("oncommand", "tinyurl_saved_add('"+ url.tiny +"', '"+ url.orig +"');");
				document.getElementById("save-button").disabled = false;
				document.getElementById('tinyurlDialogMain').style.cursor = "default";
			}
			else{
				document.getElementById("tinyurl-field").value = "";
				alert("An error occurred.\nIs your internet connection available?");
			}
		});
		
	}catch(err){ alert("Error 120\nAn unknown error occurred\n"+ err); }
}

/**
* Create TinyUrl from anchor on page
*/
function tinyurl_createFromAnchor(){		
	if(gContextMenu != null && (gContextMenu.getLinkURL || gContextMenu.linkURL)){		
		var url = (gContextMenu.getLinkURL) ? gContextMenu.getLinkURL() : gContextMenu.linkURL
		var tiny = new TinyUrl.URL(url);

		window.openDialog('chrome://tinyurl/content/create.xul','TinyUrlCreate','chrome, centerscreen, resizable', tiny);
	}
}

//Send text to tinyurl_copyText()
function tinyurl_copy(){
	try{
		var oField = document.getElementById("tinyurl-field");
		
		if(oField == null || oField.value == ""){
			return;
		}
		
		//Copy
	  	tinyurl_copyText(oField.value);
		
	}catch(err){ alert("Error 140\nCouldn't copy to clipboard"); }
}

// Comand from key stroke
function tinyurl_copy_command(){
	if(oTabBox.selectedTab.id == "tinyurl-create-tab"){
		tinyurl_copy();
	}
	else if(oTabBox.selectedTab.id == "tinyurl-saved-tab"){
		tinyurl_saved_copy();
	}
}

//Copies str to clipboard
function tinyurl_copyText(str){
	try{
		//Copy
		var oClipboard 	= Components.classes["@mozilla.org/widget/clipboardhelper;1"].getService(Components.interfaces.nsIClipboardHelper);
	  		oClipboard.copyString(str);
			
	}catch(err){ throw err }
}

// Context Showing
function tinyurl_contextShowing(event){
	try{
		if(document.popupNode.nodeName.toUpperCase() == "A"){
			document.getElementById("tinyurl-context-link-menu").setAttribute("collapsed", false);
		}
		else {
			document.getElementById("tinyurl-context-link-menu").setAttribute("collapsed", true);
		}
	} catch(e) {}
}

//Opens http://tinyurl.com
function tinyurl_gotoTinyUrl(){
	opener.focus();
	self.focus();
	
	if(opener.gBrowser.addTab)
		opener.gBrowser.selectedTab = opener.gBrowser.addTab("http://tinyurl.com");
	else
		window.open("http://tinyurl.com");
}
